class Admin::Ckeditor::AssetsController < Admin::BaseController  
  layout "admin/dialog"
  
  def index
    @assets = current_resource_class_timestamped? ? current_resource_class.unscoped.order("created_at DESC") : current_resource_class.unscoped.order("id DESC")
    @assets = @assets.page(params[:page])
  end
  
  def create
    @asset  = current_resource_class.new({attachment_name => params[:file]})
    @asset.save!
    render :format => :js
  end
  
  def destroy
    # @asset loaded by Admin::BaseController

    current_resource.destroy
    render :format => :js
  end
  
  protected
  
  def current_resource_class_timestamped?
    current_resource_class.columns.include?("created_at")
  end
  
  def current_resource_attachment
    current_resource.send(attachment_name)
  end

  helper_method :asset_attachment
  def asset_attachment(asset)
    asset.send(attachment_name)
  end

  # ====================
  # = Abstract Methods =
  # ====================

  def current_resource_class
    raise NotImplementedError
  end

  def attachment_name
    raise NotImplementedError    
  end
  
end